#!/usr/bin/python
# -*- coding: latin-1 -*-

# Copyright (c) 2008 by Bernd Kalwar
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA


from turbogears import controllers, expose, flash
# from model import *
from turbogears import identity, redirect
from cherrypy import request, response
from vlab.subcontrollers.user.usersubcontroller import UserSubController
#from vlab.subcontrollers.user.adminsubcontroller import AdminSubController
from vlab.subcontrollers.project.projectsubcontroller import ProjectSubController
from vlab.subcontrollers.ide.idesubcontroller import IdeSubController
from vlab.subcontrollers.microcontroller.mccontroller import MCSubController
from vlab.subcontrollers.ide.console import ConsoleController
# from vlab import json
# import logging
# log = logging.getLogger("vlab.controllers")

class Root(controllers.RootController):
    @expose(template="vlab.templates.welcome")
    # @identity.require(identity.in_group("admin"))
    def index(self):
        import time
        # log.debug("Happy TurboGears Controller Responding For Duty")
        flash("Your application is now running")
        return dict(now=time.ctime())

    @expose(template="vlab.templates.login")
    def login(self, forward_url=None, previous_url=None, *args, **kw):

        if not identity.current.anonymous \
            and identity.was_login_attempted() \
            and not identity.get_identity_errors():
            raise redirect(forward_url)

        forward_url=None
        previous_url= request.path

        if identity.was_login_attempted():
            msg=_(u"Die Anmeldedaten waren nicht korrekt oder Sie besitzen nicht die ntigen Rechte, auf diese Seite zuzugreifen.")
        elif identity.get_identity_errors():
            msg=_(u"Sie mssen sich anmelden, bevor Sie auf die Seiten zugreifen drfen.")
        else:
            msg=_(u"Bitte melden Sie sich an.")
            forward_url= request.headers.get("Referer", "/")

        response.status=403
        return dict(message=msg, previous_url=previous_url, logging_in=True,
                    original_parameters=request.params,
                    forward_url=forward_url)


    @expose()
    def logout(self):
        identity.current.logout()
        raise redirect("/")

    # add subcontrollers to cherrypy object tree
    user = UserSubController()
 #   admin = AdminSubController()
    projects = ProjectSubController()
    controller = MCSubController()
    ide = IdeSubController()
    console = ConsoleController()
