#!/usr/bin/python
# -*- coding: latin-1 -*-

# Copyright (c) 2008 by Bernd Kalwar
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA


from turbogears import identity, expose, redirect, flash, controllers
from turbogears import widgets, validators, error_handler, validate

import cherrypy
from sqlobject.sqlbuilder import *

#from vlab.model import VlabControllerInstance
import os

PROJECT_DIR= cherrypy.config.get("vlab.projectdir")

class ConsoleController(controllers.Controller):
    require = identity.not_anonymous()


    @expose()
    def index(self):
        #select controller 2 use

        return dict()

    @expose('json')
    def imalive(self):
        from datetime import datetime, timedelta
        from vlab.model import MicroControllerUse, MicroController, Reservation
        availableuntil = datetime.now() + timedelta(minutes=60)
        msg = ""
        error = False
        if cherrypy.session.get('controllerid', -1) == -1:
            cherrypy.session['destroyterm'] = True
        else:
            mc = MicroController.get(cherrypy.session.get('controllerid'))
            mcu = MicroControllerUse.selectBy(micro_controller = mc)



            res = Reservation.selectBy(micro_controller = mc).orderBy('fromtime')
            res = res.filter(Reservation.q.fromtime >= datetime.now())
            if res.count() > 0:
                if res[0].user != identity.current.user:
                    availableuntil = res[0].fromtime

                    if availableuntil <= datetime.now() + timedelta(minutes=1):

                        error = True
                        cherrypy.session['destroyterm'] = True
                        cherrypy.session['controllerid'] = -1
                        msg = "Ihre Sitzung wurde aufgrund einer Reservierung terminiert!"



            if mcu.count() == 0:
                mcu = MicroControllerUse(micro_controller = mc, user = identity.current.user,
                                         expiry = datetime.now() + timedelta(minutes=5))

            else:
                mcu[0].set(created = datetime.now(), expiry = datetime.now()+ timedelta(minutes=1), user = identity.current.user)
        timeleft = availableuntil - datetime.now()

        return dict(error = error, lastact = datetime.now(), timeleft = timeleft.seconds, errormsg = msg)

    @expose('json')
    def resetcontroller(self):

        error = self.execcmd(cmd = "reset")
        return dict(error = error)

    @expose('json')
    def downloadprogram(self):
        return dict()

    @expose('json')
    def reinit(self):
        cherrypy.session['term'] = None
        error = self.copyprojectfiles()
        error = error + "\n" + self.resetcontroller()
        return dict(error = error)


    @expose('json')
    def copyprojectfiles(self, projectid = None, controllerid = None):
        from vlab.model import UserProject, MicroController, MicroControllerUse
        error = ""

     #   try:
        if projectid == None or controllerid == None:
            error = "Fehler bei copyprojectfiles() 1"
        else:
            project = UserProject.get(projectid)
            mc = MicroController.get(controllerid)

            # is controller currently used by other user?
            mcu = MicroControllerUse.selectBy(micro_controller = mc)

            if (mcu.count() == 0) or (mcu[0].user == identity.current.user):
                dest_dir = os.path.join("/home", mc.linux_user)
                source_dir = os.path.join(PROJECT_DIR, project.user.display_name,str(project.id))
                cmd = "rm -r " + dest_dir + "/"
                print cmd
                stdin, stdout = os.popen4(cmd)
                cmd = "cp " + source_dir +"/* " +dest_dir
                print cmd
                stdin, stdout = os.popen4(cmd)
            else:
                error = _(u"Ein anderer Benutzer nutzt gerade den gewhlten Controller")

       # except:
         #   error = _(u"Fehler beim Aufruf copyprojectfiles() 2")

        return dict(error = error)

    @expose('json')
    def power(self):
        error = self.execcmd(cmd = "power")
        return dict(error = error)

    def execcmd(self, cmd):
        error = ""
        try:
            if cherrypy.session.get('controllerid', -1) == -1:
                cherrypy.session['destroyterm'] = True
            else:
                mc = MicroController.get(cherrypy.session.get('controllerid'))
            print "ID"
            print mc.id

            if cmd == "power":
                cmd = mc.cmd_power
                pass
            elif cmd == "reset":
                cmd = mc.cmd_reset
            elif cmd == "reinit":
                cmd = mc.cmd_init
            else:
                cmd = "echo "
                error = "kein Befehl"

            dest_dir = os.path.join("/home", ci.envuser)
            os.chdir(dest_dir)
            os.system(cmd)

            print "FERTICH"

        except:
            error = "Fehler beim Aufruf des Befehls " + cmd

        return error


