from turbogears import controllers, expose, widgets, flash, validators, identity, redirect
from kid import Element
from sqlobject import *
from vlab.model import User, UserProject, ProgrammingLanguage, Group



class UserFilterFields(widgets.WidgetsList):
    user = widgets.TextField(label = "Benutzername: ")

class PLForm(widgets.WidgetsList):
    #add default with id = -1
    language = widgets.TextField(label = "Sprache: ")
    testable = widgets.CheckBox()



    #submit_button = widgets.ImageButton(label = '', src = "/static/images/ok.png")

userinfo =  widgets.DataGrid(fields=[
                                        (u'Benutzer', lambda row: row[1]),
                                        (u'angemeldet seit:', lambda row: row[2]),
                                        (u'entfernen:', lambda row: row[3])
                                    ])

pldatalist = widgets.DataGrid(fields=[
                                (u'Sprache:', lambda row: row[1]),
                                (u'Online testbar:', lambda row: row[2])
                             ])
# admin subcontroller
class AdminSubController(controllers.Controller):

    @identity.require(identity.All(identity.in_group("admin")))
    @expose(template="vlab.templates.usersubcontroller.admin")
    def index(self):
        """

        """
        tabber = widgets.Tabber()

        user_searchform = widgets.RemoteForm(
                                     name="ItemSearch",
                                     fields=UserFilterFields(),
                                     submit_text="filtern")

        filter = widgets.FieldSet(fields = user_searchform)

        cb = widgets.CheckBox().display()

        data = [(user.id, self.makeUsernameLink(user.user_name), user.created, cb)
                    for user in  User.select()]


        pldata = [(p.id, p.language)
                    for p in  ProgrammingLanguage.select()]



        return dict(tabber = tabber, user_searchform = user_searchform, usergrid = userinfo, data = data,
                    pldata = pldata, pldatalist = pldatalist)



    def makeUsernameLink(self, username):
        link = Element('a', href='/user/userinfo/%s' % username)
        link.text = username
        return link

    @expose()
    def searchuser(self, **kw):
        cb = widgets.CheckBox().display()

        data = [(user.id, self.makeUsernameLink(user.user_name), user.created,cb)
                        for user in  User.select(User.q.user_name.startswith(kw['user']))]

        # return renderd data
        return userinfo.render(data)

    @expose()
    def createdummy(self):
        try:

            u = User(user_name = 'admin', display_name = 'admin', email_address = 'admin@localhost.de', password = '123abc')
            g = Group.selectBy(group_name = 'admin')
          #  g = Group(group_name = 'admin', display_name = 'admin')
            g.add(u)
            flash('Dummydaten erstellt')
        except:
            flash('Fehler beim Erstellen der Dummydaten')
        raise redirect('/user')
