from turbogears.widgets import Widget
from turbogears import identity
from sqlobject import *

class NewestUserWidget(Widget):
    from vlab.model import User
    users = User.select(orderBy='-created',limit=5)
    template = 'vlab.widgets.templates.infobox'
    template_vars = ['title','users']
    read_only = True

newestuser_widget = NewestUserWidget()

class UserOnlineWidget(Widget):
    from vlab.model import User

    from vlab.model import VisitIdentity, Visit
    from sqlobject import *
    from sqlobject.sqlbuilder import *
    import datetime

    #get all ids of online user
    subselect = Select(VisitIdentity.q.user_id, where=AND(Outer(Visit).q.visit_key == VisitIdentity.q.visit_key, Visit.q.expiry > datetime.datetime.now()))
    users = User.select(IN(User.q.id, subselect))

    #users = User.select(orderBy='created',limit=5)
    template = 'vlab.widgets.templates.useronlinewidget'
    template_vars = ['title','users']
    read_only = True

#useronline_widget = UserOnlineWidget()

class ControllerAvailableWidget(Widget):
    from vlab.model import MicroController
    controllers = MicroController.select()

    template = 'vlab.widgets.templates.controllerwidget'
    template_vars = ['title','controllers']
    read_only = True



